--if (LUA["TRAIN"] ~= nil) then return end

local TRAIN_START_X = 785
local TRAIN_START_Y = -400
local TRAIN_END_X = 785
local TRAIN_END_Y = 15000

local TRAIN_SOUNDRADIUS = 4500
local TRAIN_SOUNDPLAYTIME = 6.4

local HZ_OFFSETX, HZ_OFFSETY = -30, -267
local HZ_WIDTH, HZ_HEIGHT = 66, 630
local HZ_MODE = 101

train = {	x = TRAIN_START_X,
			y = TRAIN_START_Y,
			speed = 9,
						--xoffset 	yoffset
			wall_zone = {{	-61,	-208},
						 {	-42,	-278},
						 {	 41,	-278},
						 {	 62,	-208},
						 {	 62,	 212},
						 {	 38,	 282},
						 {	-37,	 282},
						 {	-61,	 212}},
						 
			dead_zone = {{	-50,	210},
						 {	 50,	210},
						 {	 32,	266},
						 {	-32,	266}},
					
			player = {},
			img = image("gfx/train.png", TRAIN_START_X, TRAIN_START_Y, 1),
}

imagehitzone(train.img, HZ_MODE, HZ_OFFSETX, HZ_OFFSETY, HZ_WIDTH, HZ_HEIGHT)

function train.main()
	
	train.y = train.y  + train.speed
	if (train.y >= TRAIN_END_Y) then train.y = TRAIN_START_Y end
	
	imagepos(train.img, train.x, train.y, 0)
	
	for _, id in pairs(player(0, "tableliving")) do
		local plr_pos = {player(id, "x"), player(id, "y")}
		local img_pos = {object(train.img, "x"), object(train.img, "y")}
		local radiusx, radiusy, radius = get_radius(plr_pos, img_pos)
		
		if (train.player[id] == nil) then train.player[id] = {xold = 0, yold = 0, sound = false, tm = 0} end
		
		if check_collision(plr_pos, img_pos, train.dead_zone) then
			parse(("customkill 0 \"Train\" %d"):format(id))
		elseif check_collision(plr_pos, img_pos, train.wall_zone) then
			parse(("setpos %d %d %d"):format(id,train.player[id].xold, train.player[id].yold))
		else
			train.player[id].xold = plr_pos[1]
			train.player[id].yold = plr_pos[2]
		end
		
		if (radius <= TRAIN_SOUNDRADIUS) then
			if (os.clock() - train.player[id].tm >= TRAIN_SOUNDPLAYTIME) then
				parse(("sv_sound2 %d \"env/train_move.ogg\""):format(id))
				train.player[id].sound = true
				train.player[id].tm = os.clock()
			end
		else
			if train.player[id].sound then
				parse(("sv_stopsound \"env/train_move.ogg\" %d"):format(id))
				train.player[id].sound = false
				train.player[id].tm = 0
			end
		end
	end
	timer(1, "train.main")
end	train.main()

function check_collision(pos_1, pos_2, dots_offset) -- (dots_offset in table), example: dots_offset = {{x2offset, y2offset}, {x2offset, y2offset}, ... }
	local x1, y1 = pos_1[1], pos_1[2] -- (pos_1 in table),  example: pos_1 = {x1, y1}
	local x2, y2 = pos_2[1], pos_2[2] -- (pos_2 in table),  example: pos_2 = {x2, y2}
	
	local function dot_pos(dot_num, axis)
		if (axis == "x") then return x2 + dots_offset[dot_num][1] end
		return y2 + dots_offset[dot_num][2]
	end
	
	local lt_p, state = #dots_offset, false
	
	for i = 1, #dots_offset do
		if (dot_pos(i, "y") < y1 and dot_pos(lt_p, "y") >= y1 or dot_pos(lt_p, "y") < y1 and dot_pos(i, "y") >= y1) then
			if (dot_pos(i, "x") + ( y1 - dot_pos(i, "y") ) / (dot_pos(lt_p, "y") - dot_pos(i, "y")) * (dot_pos(lt_p, "x") - dot_pos(i, "x")) < x1) then
				state = not state
			end
		end
		lt_p = i
	end
	
	return state
end

function get_radius(pos_1, pos_2)
	local x1, y1 = pos_1[1], pos_1[2] -- (pos_1 in table),  example: pos_1 = {x1, y1}
	local x2, y2 = pos_2[1], pos_2[2] -- (pos_2 in table),  example: pos_2 = {x2, y2}
	
	local radiusx = math.floor(((x2 - x1)^2)^0.5)
	local radiusy = math.floor(((y2 - y1)^2)^0.5)
	local radius = math.floor((x2 - x1)^2 + (y2 - y1)^2)^0.6
	
	return radiusx, radiusy, radius		-- return 3 value , 1 - radius from x, 2 - radius from y, 3 - absolute radius
end
